function [dx, dy, translation_im] = phase_corr(im1, im2)
    
f1 = fft2(im1); 
f2 = fft2(im2); 

cc = f1.*conj(f2);
ncc = cc./(1e-7 + abs(cc)); 
translation_im = fftshift( ifft2(ncc) ); 

% find max: 
[~, idx] = max( abs(translation_im(:)) ); 
% position of max: 
[y, x] = ind2sub(size(translation_im), idx); 

% compute shift: 
[cx, cy] = ffcenter(translation_im); 

dx = x - cx;
dy = y - cy; 

